/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.utils.api.repository;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;



/**
 * Example查询参数
 *
 * @author Lucky Yang
 */
public class ExampleParameter extends Parameter {
	private Object example;

	public ExampleParameter() {
		super();
	}

	public ExampleParameter(Object example) {
		super();
		this.example = example;
	}

	public ExampleParameter(Object example,int start, int limit) {
		super(start,limit);
		this.example = example;
	}

	public Object getExample() {
		return example;
	}

	@Override
	public boolean isValid() {
		return (this.example != null);
	}	
	
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}	
}
