/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */
package net.sourceforge.kivu4j.utils.api.repository;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Query查询参数
 *
 * @author Lucky Yang
 */
public abstract class QueryParameter extends Parameter { 
	private Map<String, Object> parameters = new HashMap<String, Object>();
	
	private String query;
	private boolean isNative;
	
	protected void setNative(boolean isNative){
		this.isNative = isNative;
	}
	
	public QueryParameter() {
		super();
	}

	public QueryParameter(String query) {
		super();
		this.query = query;
	}

	public QueryParameter(String queryName, int start, int limit) {
		super(start, limit);
		this.query = queryName;
	}

	public String getQuery() {
		return query;
	}

	public void setQuery(String query) {
		this.query = query;
	}

	public boolean isNative() {
		return isNative;
	}

	public void setParameters(Map<String, Object> parameters) {
		this.parameters = parameters;
	}

	public Map<String, Object> getParameters() {
		return parameters;
	}
	
	public void add(String name, Object value) {
		this.parameters.put(name, value);
	}
	
	public void clear(){
		this.query = null;
		this.parameters.clear();
	}


	@Override
	public boolean isValid() {
		return (StringUtils.isNotBlank(this.query) && this.parameters != null);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
	

}
